Initiate partner settlement
Used by dispute enabled exchange partners to stage a settlement for connected clients.
This endpoint will:
- Authenticate the request by verifying the payload and signature provided.
- Create entities: a. Create the settlement entity b. Map provided settlement amounts to settlement transfer records for execution.
- Assign closed, unassigned disputes from prior settlements to this settlement a. Pull in any adjustedSettlementTransfers from said disputes. b. Update the settledInSettlementId on said disputes.
- Verify the relevant connection balances against liabilities based on provided settlementAmounts and assigned settlement transfers from disputes being assigned.
- Notify connection owners of a new settlement.
- Queue an event to finalize the settlement once the dispute window ends.
This endpoint is idempotent and can safely be called again with the same exact request body without worrying about creating multiple settlements.
Please note that provided settlement amounts should be based solely on new trading activity that was not included in the last settlement. Instructions from closed, unsettled disputes should not be included in the calculation of settlement instructions on the Settlement will be processed asynchronously once initiated, after dispute / top up window have elapsed.
- Error scenarios:
-
400: Invalid Request Error
-
Occurs when the request parameters are invalid or malformed.
-
Examples: Invalid format for settlement amounts, missing required fields, invalid signature.
-
401: Authentication Error or Incomplete Settlement
-
Occurs when the request is not authorized or cannot be completed immediately.
-
Examples: Caller is not a member of the enterprise, signature verification failed.
-
403: Permission Denied Error
-
Occurs when the authenticated partner doesn't have necessary permissions.
-
Examples: Enterprise does not have OES license, partner is inactive
-
409: Conflict Error
-
Occurs when the request conflicts with current state.
-
Examples: Settlement already exists with the same externalId and different properties.
-
422: Unprocessable Content
-
Occurs when the request is authenticated and permitted but is unable to be processed.
-
Examples: the liabilities for one or more connection exceed their allocated balance.
-
500: Internal Server Error or Incomplete Settlement
-
Occurs when there's an unexpected server error processing the request.
-
Examples: Database connection issues, settlement initiated but not completed due to transient errors.
Requires access token scopes: settlement_network_read, settlement_network_write
Path Params
-
enterpriseIdstring requiredThe enterprise identifier of the partner. This identifies the partner enterprise making the API request.
Body Params
object
-
externalIdstring requiredExternal identifier for the settlement request. This should be unique for each settlement request and is used for idempotence and correlation with partner systems. -
notesstringOptional notes about the settlement. Can contain additional context or information about the purpose of the settlement. -
settlementAmountsobject requiredONE OF
-
<key>map of stringsvalue object
-
<key>stringFor unmapped settlement amounts where the amount can be either BigNumberFromString or BigIntFromString. This provides flexibility in how monetary values are represented in settlement requests.
-
-
<key>map of objectsvalue object
-
<key>map of stringsvalue object
-
<key>stringFor unmapped settlement amounts where the amount can be either BigNumberFromString or BigIntFromString. This provides flexibility in how monetary values are represented in settlement requests.
-
-
-
-
noncestring requiredA unique nonce value used for cryptographic operations. This provides additional security for settlement operations. -
payloadstring required -
signaturestring required -
cutoffAtstring date-time requiredThe date and time of the most recent trade being settled, represented in ISO 8601 format
Responses
200
OK
Response Body
object
-
settlementobject requiredThe initiated settlement object in it's pending state.settlement object
-
cutoffAtstring date-time requiredThe datetime provided by the partner representing the timestamp of the most recent trade being settled. -
settlingDisputesarray of objects requiredArray of disputes that were closed and not yet assigned at the time the request was first received. These disputes are assigned to the settlement and their associated adjustedSettlementTransfers will be executed with this settlement regardless of whether or not the associated client(s) dispute.settlingDisputes object
-
settledInSettlementIdstring required -
disputeClosureIdstring required -
disputeClosureobject requireddisputeClosure object
-
idstring requiredThe unique identifier of the dispute closure. -
closedBystring enum requiredWho closed the dispute.
admin- The dispute was closed by an admin.client- The dispute was closed by a client.
clientadmin -
userIdstring requiredThe id of the user who closed the dispute. -
notesstring requirednotes entered by the user when closing the dispute. -
adjustedSettlementTransfersarray of objects requiredThe resulting settlement transfers generated when the dispute was closedadjustedSettlementTransfers object
-
idstring requiredThe unique identifier of the settlement transfer. -
sourceTradingAccountIdstring requiredThe go account id of the source party. -
destinationTradingAccountIdstring requiredThe go account id of the destination party. -
destinationNetworkAccountIdstring requiredThe network account id of the destination party. -
disputeClosureIdstring requiredThe unique identifier of the dispute closure the settlement transfer was created from. This is a UUID that uniquely identifies dispute closure if the transfer was created as a result of closing a dispute. -
currencystring requiredThe currency involved in the settlement movement. -
quantitystring requiredThe amount of currency being transferred in the settlement transfer. This is a non-zero value represented as a string. If the value is positive, that means funds were moved from the source account to the destination account. If the value is negative, that means funds were moved from the destination account to the source account. -
statusstring enum requiredThe status of the settlement transfer. Possible values and implications are:
- pending: The transfer is pending and has not yet been processed.
- pending_onchain: The transfer is pending on-chain movement (only relevant to on-chain settlements).
- onchain_initiated: The transfer has been initiated on-chain (only relevant to on-chain settlements).
- onchain_failed: The on-chain transfer has failed (only relevant to on-chain settlements).
- completed: The transfer has been completed successfully.
- failed: The transfer has failed.
- rejected: The transfer has been rejected.
- disputed: The transfer is disputed.
pendingpending_onchainonchain_initiatedonchain_failedcompletedfailedrejecteddisputedpending_settlement_assignment -
createdAtstring date-time requiredThe date and time when the settlement transfer was created. Represented as an ISO 8601 formatted date string. -
updatedAtstring date-time requiredThe date and time when the settlement transfer was last updated. Represented as an ISO 8601 formatted date string. -
settlementIdstringThe unique identifier of the settlement the settlement transfer is associated with. This is a UUID that uniquely identifies the settlement. Will only be undefined if the settlement transfer is inpending_settlement_assignmentstatus. -
sourceNetworkAccountIdstringThe network account id of the source party.
-
-
createdAtstring date-time requiredThe date and time when the dispute closure was created. -
statusstring enum requiredThe status of the dispute closure review.pending_reviewapprovedrejected -
adjustedTransfersmap of strings requiredThe adjusted transfers as a result of the dispute closure.adjustedTransfers object
-
<key>string
-
-
reviewedBystringThe id of the admin who reviewed the dispute closure. -
reviewNotesstringAny comments entered by the admin when reviewing the dispute closure.
-
-
idstring required -
createdAtstring date-time required -
updatedAtstring date-time required -
connectionIdstring required -
disputedSettlementIdstring required -
userIdstring required -
expectedTransfersmap of strings requiredexpectedTransfers object
-
<key>string
-
-
retractedboolean required -
settledInSettlementIdstring required -
reasonstring -
retractedBystring -
retractedAtstring date-time -
disputeClosureIdstring required -
retractedReasonstring
-
-
idstring requiredThe unique identifier of the settlement. This is a UUID that uniquely identifies the settlement record. -
partnerIdstring requiredThe unique identifier of the partner the settlement is associated with. This is a UUID that uniquely identifies the partner. -
externalIdstring requiredExternal identifier provided by the partner when creating the settlement. -
statusstring enum requiredpending -
settlementTypestring enum requiredThe type of settlement. Possible values are:
- onchain: The settlement is on-chain.
- offchain: The settlement is off-chain.
onchainoffchain -
reconciledboolean requiredWhether or not the settlement is reconciled against trade data. Currently there are no reconciled settlements. This field is always false. -
initiatedBystring requiredId of the user which initiated the settlement. -
notesstringThe notes associated with the settlement. This is a free-form text field that can contain any additional information about the settlement. -
createdAtstring date-time requiredThe date and time when the settlement was created. This is a timestamp in ISO 8601 format. -
updatedAtstring date-time requiredThe date and time when the settlement was last updated. This is a timestamp in ISO 8601 format. -
rtIdstringRouted transaction id associated with the settlement. This is a UUID that uniquely identifies the routed transaction. This field is only populated for on-chain settlements for partners with automation enabled. -
lossSLAAlertSentboolean requiredWhether or not an alert has been sent if loss settlement SLA is close to being breached. Only relevant for on-chain settlements. -
gainSLAAlertSentboolean requiredWhether or not an alert has been sent if gain settlement SLA is close to being breached. Only relevant for on-chain settlements. -
cutoffAtstring date-time requiredThe date and time of the newest trade being settled in the partner system. This is a timestamp in ISO 8601 format. This field is only populated for dispute enabled partners. -
disputedbooleanWhether or not a dispute was raised on this settlement.
-
401
Unauthorized
Response Body
object
-
errorstring required
403
Forbidden
Response Body
object
-
errorstring required
409
Conflict
Response Body
object
-
errorstring required
422
Unprocessable Entity
Response Body
object
-
errorstring required
500
Internal Server Error
Response Body
object
-
errorstring required